# create the dictionaries to hold the values
occupations = {}
occupation_count = {}


# open the file with previously saved occupations
try:
    fp = open("occupations.txt")
    for line in fp:
        name, occupation = line.split(':')
        # strip whitespace and change capitals
        name = name.strip().capitalize()
        occupation = occupation.strip().lower()
        # add the name-occupation pair to the dict
        occupations[name] = occupation
        # count the occupation
        occupation_count[occupation] = occupation_count.get(occupation, 0) + 1
    fp.close()
except FileNotFoundError:
    print('No previous occupations saved.')


# continue asking for input until the user quits
while True:
    print('Enter a name: (or q to quit)')
    # always save name with same capitalization (first letter only)
    name = input().capitalize()
    # we capitalized the input so q -> Q
    if name == 'Q' or name == 'Quit':
        break
    # lookup the occupation
    if name in occupations:
        is_a = 'is a'
        # if first letter of occcupation is a vowel, change for grammar
        if occupations[name][0] in 'aeiou':
            is_a = 'is an'
        # capitalize the first letter of the name for grammar
        print(name, is_a, occupations[name])
    else:
        print('I don\'t know the occupation of', name)
        print('What is their occupation?')
        # always save occupation with same capitalization (no capitals)
        occupation = input().lower()
        # add the name-occupation pair to the dict
        occupations[name] = occupation
        # count the occupation
        occupation_count[occupation] = occupation_count.get(occupation, 0) + 1


print('Occupation count:')
# sort the occupations from highest count to lowest
for key, value in sorted(occupation_count.items(), reverse=True):
    print(key, ':', value)


# write all the name-occupation pairs to a file
# use "w" because we saved everything in the dictionary again
# and we don't want to create double entries
fp = open("occupations.txt", "w")
for name in occupations:
    fp.write(name + ": " + occupations[name] + '\n')
fp.close()
